<template>
  <div class="container">
    <div class="progress-bar-container">
      <progress-bar
        :barWidth="barWidth"
        :quizLength="quizLength"
        :questionNumber="questionNumber"
      />
    </div>
    <div class="quiz-body">
      <div v-if="questionNumber" class="question-number">
        Question {{ questionNumber }}
      </div>
      <div class="questionText" data-testid="question-text">
        {{ questionText }}
      </div>
      <div
        class="question-image-container"
        v-if="imageSrc"
        data-testid="question-image-container"
      >
        <div
          :style="imageStyle"
          class="question-image"
          data-testid="question-image"
        />
        <image-expand-icon
          class="image-sizer-icon"
          @click="handleImageExpansion"
          data-testid="expand-image"
        />
      </div>
      <div
        v-if="isImageExpanded && imageSrc"
        @click="handleImageExpansion"
        class="upc-modal question-image-modal"
      >
        <div
          class="question-image-expanded-container"
          data-testid="question-image-expanded-container"
        >
          <image-collapse-icon
            class="image-sizer-icon"
            @click="handleImageExpansion"
            data-testid="collapse-image"
          />
          <img :src="imageSrc" class="question-image--expanded" />
        </div>
      </div>
      <form class="possible-answers" data-testid="quiz-questions">
        <div v-for="(item, index) in items" :key="`item-${index}`">
          <div class="options answer-option">
            <input
              :value="item.val"
              v-model="picked"
              type="radio"
              :id="item.val"
              :data-testid="item.val"
              class="answer-option--input"
            />
            <label
              :for="item.val"
              :id="'answer-' + item.val"
              :data-testid="`$answer-${item.val}`"
              class="answer-option--label"
            >
              {{ item.val }}. {{ item.txt }}
            </label>
          </div>
        </div>
        <p class="quiz-error">{{ errorMsg }}</p>
      </form>
    </div>
    <div class="btn-container">
      <button
        v-if="showPrevious"
        data-testid="btn-question-previous"
        class="prev btn"
        type="button"
        @click.prevent="previous()"
      >
        PREVIOUS
      </button>
      <button
        data-testid="btn-question-next"
        v-if="showNext"
        class="next btn"
        type="button"
        @click.prevent="next()"
      >
        NEXT
      </button>
      <button
        data-testid="btn-submit-quiz"
        v-if="showSubmit"
        class="submit btn"
        type="submit"
        @click.prevent="submit()"
      >
        SUBMIT QUIZ
      </button>
    </div>
  </div>
</template>

<script>
import TrainingService from '@/services/TrainingService'

import ProgressBar from './ProgressBar.vue'
import ImageExpandIcon from '@/assets/image-expand.svg'
import ImageCollapseIcon from '@/assets/image-collapse.svg'
import LoggerService from '@/services/LoggerService'

export default {
  props: ['quizLength'],
  data() {
    return {
      picked: '',
      showPrevious: false,
      showNext: false,
      showSubmit: false,
      questionNumber: 0,
      barWidth: 0,
      questionText: '',
      items: [],
      imageStyle: {},
      errorMsg: '',
      imageSrc: '',
      isImageExpanded: false,
    }
  },
  components: {
    ProgressBar,
    ImageExpandIcon,
    ImageCollapseIcon,
  },
  mounted() {
    this.getFirstQuestion()
  },
  beforeUpdate() {
    // manually set questionText since MathJax's generated DOM elements interfere
    // with Vue's template engine when changing the text
    const questionText = document.querySelector('.questionText')
    if (questionText) questionText.innerHTML = this.questionText
  },
  updated() {
    this.rerenderMathJaxElements()
  },
  emits: ['submitQuiz'],
  methods: {
    clearMathJaxElements() {
      const quizBody = document.querySelector('.quiz-body')
      if (!quizBody) {
        LoggerService.noticeError(
          'Missing quiz body - cannot clear MathJax elements'
        )
        return
      }

      // Remove any MathJax-rendered elements from the DOM.
      // Do this before updating to avoid rendering artifacts being left behind
      const mathJaxElements = Array.from(
        quizBody.querySelectorAll('[class*=mjx],[class*=MathJax],[id*=MathJax]')
      )

      const mathJaxParentElements = Array.from(
        quizBody.querySelectorAll('.MathJax_Preview')
      ).map((e) => e.parentElement)

      mathJaxElements.forEach((e) => e.remove())

      // MathJax slices up the DOM nodes it renders as math formulas. We need to
      // rejoin these under the first child's data attribute to avoid artifacts
      // being left behind
      mathJaxParentElements.forEach((parentEl) => {
        if (!(parentEl && parentEl.firstChild)) return

        parentEl.firstChild.data = parentEl.innerText

        // Remove all child nodes but the first
        Array.from(parentEl.childNodes)
          .slice(1)
          .forEach((e) => e.remove())
      })
    },

    rerenderMathJaxElements() {
      const quiz = document.querySelector('.quiz-body')
      if (!quiz) {
        LoggerService.noticeError(
          'Missing quiz body - cannot rerender MathJax elements'
        )
        return
      }
      const questionText = quiz.querySelector('.questionText')
      const answerChoices = quiz.querySelectorAll('.possible-answers div')

      if (!questionText || !answerChoices || !answerChoices.length) {
        return
      }
      window.MathJax.Hub.Queue([
        'Typeset',
        window.MathJax.Hub,
        [
          questionText,
          ...Array.from(answerChoices).map((answerChoice) =>
            answerChoice.querySelector('.options label')
          ),
        ],
      ])
    },
    updateProgressBar() {
      // When switching to a new question, clear any mathjax elements so they
      // can be re-rendered
      this.clearMathJaxElements()

      const index = TrainingService.getIndex(this)
      this.questionNumber = TrainingService.getIndex(this) + 1
      this.barWidth = (100 / (this.quizLength - 1)) * index
      for (let i = 1; i < this.quizLength + 1; i++) {
        const element = document.getElementById(`circle-${i}`)
        if (element) {
          if (i < index + 2) {
            element.style.background = '#16D2AA'
          } else {
            element.style.background = '#EEEEEE'
          }
        }
      }
    },
    styleImage(imageSrc) {
      if (imageSrc) {
        this.imageStyle = {
          backgroundImage: `url(${imageSrc})`,
          width: '100%',
          height: '100%',
          display: 'flex',
          backgroundSize: 'contain',
          backgroundRepeat: 'no-repeat',
          backgroundPosition: 'center',
        }
      } else {
        this.imageStyle = {}
      }
    },
    getFirstQuestion() {
      const question = TrainingService.getFirstQuestion()
      this.questionText = question.questionText
      this.styleImage(question.imageSrc)
      this.imageSrc = question.imageSrc
      this.items = question.possibleAnswers
      this.showNext = true
      if (!TrainingService.hasNext()) {
        this.showNext = false
        this.showSubmit = true
      }

      this.questionNumber = TrainingService.getIndex(this) + 1
    },
    previous() {
      TrainingService.saveAnswer(this.picked)
      this.picked = ''
      const data = TrainingService.getPreviousQuestion(this)
      const { question } = data
      this.picked = data.picked
      this.questionText = question.questionText
      this.updateProgressBar()
      this.imageSrc = question.imageSrc
      this.styleImage(question.imageSrc)
      this.items = question.possibleAnswers
      if (!TrainingService.hasPrevious(this)) {
        this.showPrevious = false
      }
      if (this.errorMsg) {
        this.errorMsg = ''
      }
      this.showSubmit = false
      this.showNext = true
    },
    next() {
      TrainingService.saveAnswer(this.picked)
      this.picked = ''
      const data = TrainingService.getNextQuestion(this)
      const { question } = data
      this.picked = data.picked
      this.questionText = question.questionText
      this.imageSrc = question.imageSrc
      this.updateProgressBar()
      this.styleImage(this.imageSrc)
      this.items = question.possibleAnswers
      if (!TrainingService.hasNext(this)) {
        this.showNext = false
        this.showSubmit = true
      }
      this.showPrevious = true
    },
    submit() {
      TrainingService.saveAnswer(this.picked)
      if (!TrainingService.hasCompleted()) {
        this.errorMsg =
          'You must answer all questions before submitting the quiz!'
      } else {
        this.$emit('submitQuiz')
      }
    },
    handleImageExpansion(event) {
      event.stopImmediatePropagation()
      const { target } = event
      if (
        this.isImageExpanded &&
        target &&
        target.classList.contains('question-image--expanded')
      ) {
        return
      } else this.isImageExpanded = !this.isImageExpanded
    },
  },
}
</script>

<style lang="scss" scoped>
.container {
  width: 100%;
  margin: 0 auto;
}

.progress-bar-container {
  margin: 2em auto;
  width: 90%;
  max-width: 600px;
}

.quiz-body {
  width: 400px;
  text-align: left;
  margin: 0 auto;
  margin-bottom: 2em;
}

input[type='radio']:checked {
  background-color: #16d2aa;
}

.possible-answers {
  margin: 2em;
}

label {
  font-weight: 400;
  display: inline;
}

.options {
  margin-bottom: 10px;
}

.answer-option {
  @include flex-container(row, initial, center);

  &--label {
    margin-left: 0.2em;
    margin-bottom: 0;
  }
}

.question-number {
  font-weight: 600;
  width: 400px;
  align-self: center;
  text-align: left;
  margin-bottom: 1.4em;
}

// todo: make global button
.btn {
  background: #f6f6f6;
  border-radius: 20px;
  width: 120px;
  padding: 0.6em 0;
  color: #16d2aa;
  font-weight: 600;

  @include breakpoint-above('large') {
    width: 160px;
  }
}

.btn:hover {
  background-color: #16d2aa;
  color: #fff;
}

.quiz-error {
  color: $c-error-red;
  margin: 2em 0;
}

.btn-container {
  @include flex-container(row, space-between);
  left: 0;
  width: 100%;

  max-width: 600px;
  left: 0;
  right: 0;
  margin: 2em auto 0;
}

.questionText {
  white-space: pre-wrap;
}

.question-image {
  &-container {
    position: relative;
    width: 300px;
    height: 300px;
  }

  &-modal {
    background: rgba(0, 0, 0, 0.4);
    @include breakpoint-below('medium') {
      @include flex-container(row, initial, center);
    }
  }

  &--expanded {
    height: 100%;
    width: 100%;
  }

  &-expanded-container {
    position: relative;
    height: 100%;
    margin: 0 auto;

    @include breakpoint-below('medium') {
      width: 80%;
      height: 80%;
    }

    @include breakpoint-below('tiny') {
      width: 90%;
      height: 90%;
    }
  }
}

.image-sizer-icon {
  position: absolute;
  width: 20px;
  height: 20px;
  margin: 1em;
  top: 0;
  right: 0;
  &:hover {
    transform: scale(1.1);
    transition: scale 0.5s ease;
  }
}

@media screen and (max-width: 700px) {
  .question-number,
  .quiz-body {
    width: 100%;
  }

  .btn-container {
    width: 100%;
  }

  .progress-bar-container {
    width: 100%;
  }
}

@media screen and (max-width: 400px) {
  .btn {
    width: 100px;
  }

  // override inline styling
  .question-image {
    width: 100% !important;
  }
}
</style>
